/*
Dato lo schema dell'Esempio successivo, scrivere un programma in linguaggio C che, digitati due
numeri indicanti il router di partenza e il router di arrivo, stampi il percorso.
*/
#include <stdio.h>
#include <conio.h>
#include <string.h>

typedef struct {
  char ra[3];  // Il router ra è connesso...
  char rb[3];  // ...al router rb ...
  unsigned char p;  // ...sulla porta p
} LINK;
LINK linkrouter[] = {{"R1","R2",2},{"R2","R1",4},{"R2","R3",2},{"R3","R2",5},{"R3","R4",3},{"R4","R3",1}};

int main (void)
{
  char chS,chD, szHops[100], *pc;
  int i,rm, rd, r, ok, n = 0;

  printf("Digitare router sorgente (1..4): ");
  chS = getche();
  printf("\nDigitare router destinazione (1..4): ");
  chD = getche();

  rm = chS - '0';
  rd = chD - '0';
  r = -1;
  szHops[0] = 0;
  pc = szHops;
  n = n + sprintf(pc+n,"R%c ",rm + '0');

  while ((rm!=rd) && (n<70))
  {
      ok = -1;
      for (i=0; i<sizeof(linkrouter)/sizeof(LINK); i++)
      {
        if (linkrouter[i].ra[1] == rm + '0')
        {
          ok = i;
          if (linkrouter[i].rb[1] != r + '0')
          {
            ok = -2;
            r = rm;
            rm = linkrouter[i].rb[1] - '0';
            break;
          }
        }
      }
      if (ok>=0)
      {
        r = rm;
        rm = linkrouter[ok].rb[1] - '0';
      }
      if (ok==-1)
      {
        printf("\nImpossibile instradare");
        return 0;
      }

      n = n + sprintf(pc+n,"R%c ",rm + '0');
      printf("\nTratta: %s",szHops);
  }

  (rm==rd) ? printf(" ok") : printf("\nErrore TTL!");
  return 0;
}

